import math
import numpy as np
n = 1_000_000
x = np.linspace(0.0, 2.0*math.pi, n)
y = np.zeros(n)

# Non-vectorized code 
for i in range(0,len(x)):
   y[i] = math.sin(x[i])*math.exp(-x[i])

# Vectorized code 
y = np.sin(x)*np.exp(-x)

# Code preprended with %timeit can only be executed 
# on the IPython interactive shell
# (Note: the VSCode interactive window uses IPython 
# under the hood, and thus %timeit works there too)
%timeit for i in range(0,len(x)): \
    y[i] = math.sin(x[i])*math.exp(-x[i])

%timeit y = np.sin(x)*np.exp(-x)


def f(x):
    return x**3 + np.sin(x)*np.exp(-3*x)

x=1.0
y=f(x)
print(y)

x=np.linspace(0.0,1.0,5)
# Vectorized function call. Returns an array.
y=f(x)
print(y)
